from SCAction import SCAction
from pysc2.lib import actions
import random as rand

class ScoutEnemy(SCAction):
    
    cornerLookup = ["top-left",
                    "top-right",
                    "bottom-left",
                    "bottom-right"]

    def __init__ (self, obs, friendDims):
        super(ScoutEnemy, self).__init__(obs, friendDims) 
        

    def getCornerSector (self, cornerName, screenSector):
        if cornerName == "top-left":
            return 0 
        elif cornerName == "top-right":
            return screenSector.numSectorsX - 1
        elif cornerName == "bottom-left":
            return (screenSector.numSectorsX*screenSector.numSectorsY) - screenSector.numSectorsX
        else: #Should be bottom right
            return (screenSector.numSectorsX*screenSector.numSectorsY) - 1

    def getNextStep (self, obs, macroAction, screenSector):
        
        if len(self.marines) > 1:
            return actions.FunctionCall(actions.FUNCTIONS.select_army.id, [0])
        else:
            return actions.RAW_FUNCTIONS.no_op()
        #if macroAction.macroCounter > 1:  
            #macroAction.completeMacroStep()
            #Selectarmy
            action = super(ScoutEnemy, self).selectMarine(obs)
            if action.function == self._NO_OP: #Debug this line
                macroAction.__init__() #reset the macro counter to 0
                return actions.FunctionCall(self._NO_OP, [])
            else:
                return action
        #else: #Marine has been selected
        #    macroAction.completeMacroStep()
        #    #Determine what sector the command center is located
        #    ccSector = screenSector.getCurrentSector(self.commandCenters[0].x, self.commandCenters[0].y)
        #    if ccSector == 0: #Top-left
        #        screenSector.sectorsVistied["top-left"] = True
        #    elif ccSector == screenSector.numSectorsX - 1: #Top-right
        #        screenSector.sectorsVistied["top-right"] = True
        #    elif ccSector == (screenSector.numSectorsX*screenSector.numSectorsY) - screenSector.numSectorsX: #Bottom-left
        #        screenSector.sectorsVistied["bottom-left"] = True
        #    elif ccSector == (screenSector.numSectorsX*screenSector.numSectorsY) - 1: #Bottom-right
        #        screenSector.sectorsVistied["bottom-right"] = True
        #    #Pick a sector to sent the scout marine to
        #    while True:
        #        randomSector = rand.randint(0, len(screenSector.sectorsVistied) - 1)
        #        if screenSector.sectorsVistied[self.cornerLookup[randomSector]] == False:
        #            break
        #        #Check if all corners have already been visited
        #        if not False in screenSector.sectorsVistied:
        #            break
        #    sector = self.getCornerSector(self.cornerLookup[randomSector], screenSector)
        #    coords = screenSector.convertSector(sector)
        #    return actions.FunctionCall(self._MOVE_SCREEN, [[0], [coords[0], coords[1]]])
    

            